//+------------------------------------------------------------------+
//|                                                 r_Marossing.mq5 |
//|                                         Copyright  2006, Rosych | 
//|                                                   rosych@mail.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Rosych"
#property link "rosych@mail.ru"
#property description " "
//---   
#property version   "1.00"
//---     
#property indicator_chart_window 
//---        
#property indicator_buffers 2
//---     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//---      
#property indicator_type1   DRAW_FILLING
//---     
#property indicator_color1  clrDodgerBlue,clrHotPink
//---   
#property indicator_label1  "r_Marossing"
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET  0 //        
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint period=5;                //  
input uint speriod=5;               //    
input int  Shift=0;                 //  MA    
input int  PriceShift=0;            //      
input uint SignalBar=0;             //    
input uint AlertCount=0;            //   
input bool Push=true;               //    push-
//---   ,    
//---      
double UpBuffer[],DnBuffer[];
//---      
double dPriceShift;
//---      
string sBuySignal,sSellSignal;
//---      
int min_rates_total;
//---      
int MA_Handle[4][7]; //[ ][-1]
//+------------------------------------------------------------------+
//|             |
//+------------------------------------------------------------------+  
class CArray
  {
public: double    Array[];
  };
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
CArray Arr[4][7];
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
string GetStringTimeframe(ENUM_TIMEFRAMES timeframe)
  {
   return(StringSubstr(EnumToString(timeframe),7,-1));
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---      
   min_rates_total=int(period+speriod);
   sBuySignal="r_Marossing "+Symbol()+GetStringTimeframe(Period())+": ""  !";
   sSellSignal="r_Marossing "+Symbol()+GetStringTimeframe(Period())+": ""  !";
//---    
   dPriceShift=_Point*PriceShift;
//---   
   for(int k=0; k<4; k++)
      for(int r=0; r<7; r++)
        {
         MA_Handle[k][r]=iMA(NULL,0,period,0,ENUM_MA_METHOD(k),ENUM_APPLIED_PRICE(r+1));
         if(MA_Handle[k][r]==INVALID_HANDLE)
           {
            Print("      iMA");
            return(INIT_FAILED);
           }
        }
//---      
   SetIndexBuffer(0,UpBuffer,INDICATOR_DATA);
//---       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,   
   ArraySetAsSeries(UpBuffer,true);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
//---    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---      
   SetIndexBuffer(1,DnBuffer,INDICATOR_DATA);
//---       1
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,   
   ArraySetAsSeries(DnBuffer,true);
//---   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);
//---    1  
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---         
   string short_name="r_Marossing";
   IndicatorSetString(INDICATOR_SHORTNAME,short_name);
//---  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   for(int k=0; k<4; k++) for(int r=0; r<7; r++) if(BarsCalculated(MA_Handle[k][r])<rates_total) return(RESET);
   if(rates_total<min_rates_total) return(RESET);

//---    
   int limit,to_copy;
   static uint UpCount,DnCount,RePush;

//---     
//---    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
      limit=rates_total-int(period)-1;     //      
   else limit=rates_total-prev_calculated; //      

//---    ,    
   for(int k=0; k<4; k++) for(int r=0; r<7; r++) ArraySetAsSeries(Arr[k][r].Array,true);
//---
   to_copy=limit+1;
//---      
   for(int k=0; k<4; k++) for(int r=0; r<7; r++) if(CopyBuffer(MA_Handle[k][r],0,0,to_copy,Arr[k][r].Array)<=0) return(RESET);

//---    
   for(int bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      UpBuffer[bar]=0.0;
      for(int k=0; k<4; k++) for(int r=0; r<7; r++) UpBuffer[bar]+=Arr[k][r].Array[bar];
      UpBuffer[bar]/=28;

      //---      SMA 
      DnBuffer[bar]=0.0;
      for(int iii=0; iii<int(speriod); iii++) DnBuffer[bar]+=UpBuffer[bar+iii];
      DnBuffer[bar]/=speriod;

      UpBuffer[bar]+=dPriceShift;
      DnBuffer[bar]+=dPriceShift;
     }

   double Up0=UpBuffer[SignalBar];
   double Dn0=DnBuffer[SignalBar];
   double Up1=UpBuffer[SignalBar+1];
   double Dn1=DnBuffer[SignalBar+1];

//---     
   if(rates_total!=prev_calculated)
     {
      UpCount=0;
      DnCount=0;
     }

//---    
   if(UpCount<AlertCount && Dn1>=Up1 && Dn0<Up0)
     {
      UpCount++;
      Alert(sBuySignal);
     }

//---    
   if(DnCount<AlertCount && Dn1<=Up1 && Dn0>Up0)
     {
      DnCount++;
      Alert(sSellSignal);
     }

//---  
   if(Push && SignalBar)
     {
      if(prev_calculated!=rates_total) RePush=true;

      if(RePush)
        {
         if(Dn1>=Up1 && Dn0<Up0) if(SendNotification(sBuySignal)) RePush=false;
         if(Dn1<=Up1 && Dn0>Up0) if(SendNotification(sSellSignal)) RePush=false;
        }
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
